////////////////////////////////////////////////////////////////////////////////////////////////
//
//  HeightMap.fx ver0.0.5  }bv
//  쐬: jP
//
////////////////////////////////////////////////////////////////////////////////////////////////
// p[^錾

// }bveNX`̃TCY
#define HeightMapWIDTH   1024
#define HeightMapHEIGHT  1024

// }bvɎgItXN[obt@
shared texture MMMob_HeightMapRT : OFFSCREENRENDERTARGET <
    string Description = "OffScreen RenderTarget for HeightMap.fx";
    int Width = HeightMapWIDTH;
    int Height = HeightMapHEIGHT;
    float4 ClearColor = { 0, 0, 0, 1 };
    float ClearDepth = 1.0;
    string Format = "D3DFMT_R32F" ;
    bool AntiAlias = false;
    int Miplevels = 1;
    string DefaultEffect = 
        "self = hide;"
//**** ɓKpIuWFNgw肵Ă*******************************

        //"QLhXVer2.x = HeightMap_Obj.fx;"  // ȊŋLq(擪//͊O)

//**********************************************************************************
        "* = hide;" 
    ;
>;


// ȉ̓}bv͈͎ŵ߂̔|`
/////////////////////////////////////////////////////////////////////////////////////

// Wϊs
float4x4 WldMat         : WORLD;
float4x4 ViewProjMatrix : VIEWPROJECTION;

float AcsRy : CONTROLOBJECT < string name = "(self)"; string item = "Ry"; >;
float AcsSi : CONTROLOBJECT < string name = "(self)"; string item = "Si"; >;
static float AcsSinRy = AcsSi*sin(AcsRy);
static float AcsCosRy = AcsSi*cos(AcsRy);
static float4x4 WorldMatrix = { AcsCosRy,  0.0f, -AcsSinRy, 0.0f,
                                    0.0f, AcsSi,      0.0f, 0.0f,
                                AcsSinRy,  0.0f,  AcsCosRy, 0.0f,
                                WldMat._41_42_43_44 };
// }eAF
float4 MaterialDiffuse : DIFFUSE  < string Object = "Geometry"; >;


///////////////////////////////////////////////////////////////////////////////////////////////
// IuWFNg`iZtVhEOFFj

// _VF[_
float4 Basic_VS(float4 Pos : POSITION) : POSITION
{
    // [hWϊ
    Pos = mul( Pos, WorldMatrix );
    Pos.y += 0.05f;

    // J_̃r[ˉeϊ
    Pos = mul( Pos, ViewProjMatrix );

    return Pos;
}

// sNZVF[_
float4 Basic_PS() : COLOR0
{
    return MaterialDiffuse;
}

///////////////////////////////////////////////////////////////////////////////////////////////
// IuWFNg`peNjbN
technique MainTec < string MMDPass = "object"; > {
    pass DrawObject {
        CullMode = none;
        VertexShader = compile vs_2_0 Basic_VS();
        PixelShader  = compile ps_2_0 Basic_PS();
    }
}

technique MainTecSS < string MMDPass = "object_ss"; > {
    pass DrawObject {
        CullMode = none;
        VertexShader = compile vs_2_0 Basic_VS();
        PixelShader  = compile ps_2_0 Basic_PS();
    }
}


///////////////////////////////////////////////////////////////////////////////////////////////

//`悵Ȃ
technique ShadowTec < string MMDPass = "shadow"; > { }
technique ZplotTec < string MMDPass = "zplot"; > { }
