////////////////////////////////////////////////////////////////////////////////////////////////
//
//  HeightMap_Mask.fx ver0.0.5  ItXN[ւ̍}bv\̈f[^
//  ( HeightMap.fx Ăяo܂DItXN[`p)
//  쐬: jP
//
////////////////////////////////////////////////////////////////////////////////////////////////
// ̃p[^ύXĂ

#define Height_Near 1000.0f    // ȏ̍ʒu̓}bvɋL^Ȃ
#define Height_Far (-1000.0f)  // ȉ̒Ⴂʒu̓}bvɋL^Ȃ

// Ȃl͂牺͂Ȃł

////////////////////////////////////////////////////////////////////////////////////////////////

float3 MapAreaPos : CONTROLOBJECT < string name = "HeightMap.x"; >;
float AcsRy : CONTROLOBJECT < string name = "HeightMap.x"; string item = "Ry"; >;
float AcsSi : CONTROLOBJECT < string name = "HeightMap.x"; string item = "Si"; >;
static float AcsSinRy = sin(AcsRy);
static float AcsCosRy = cos(AcsRy);
static float4x4 InvWorldMatrix = { AcsCosRy,  0.0f,   AcsSinRy,   0.0f,
                                       0.0f,  1.0f,       0.0f,   0.0f,
                                  -AcsSinRy,  0.0f,   AcsCosRy,   0.0f,
                                  -AcsCosRy*MapAreaPos.x+AcsSinRy*MapAreaPos.z, 0.0f,
                                  -AcsSinRy*MapAreaPos.x-AcsCosRy*MapAreaPos.z, 1.0f };
// Wϊp[^
float4x4 WorldMatrix : WORLD;

////////////////////////////////////////////////////////////////////////////////////////////////
//MMMΉ

#ifdef MIKUMIKUMOVING
    #define VS_INPUT  MMM_SKINNING_INPUT
    #define GETPOS  MMM_SkinnedPosition(IN.Pos, IN.BlendWeight, IN.BlendIndices, IN.SdefC, IN.SdefR0, IN.SdefR1)
#else
    struct VS_INPUT{ float4 Pos : POSITION; };
    #define GETPOS  IN.Pos
#endif

///////////////////////////////////////////////////////////////////////////////////////////////
// }bvf[^

// _VF[_
float4 HeightMap_VS(VS_INPUT IN) : POSITION
{
    float4 Pos = GETPOS;

    // [hWϊ
    Pos = mul( Pos, WorldMatrix );

    // HeightMap.x̃[JWnɍ킹(r[Wϊǂ)
    Pos = mul( Pos, InvWorldMatrix );

    // ˉeWϊǂ
    float4 OutPos;
    OutPos.x = Pos.x;
    OutPos.y = Pos.z;
    OutPos.z = 5.0f*AcsSi * ( Height_Near - Pos.y ) / ( Height_Near - Height_Far );
    OutPos.w = 5.0f*AcsSi; // HeightMap.xANZ-5`5Ȃ̂

    return OutPos;
}

// sNZVF[_
float4 HeightMap_PS() : COLOR
{
    return float4(-1.0e30f, 0.0f, 0.0f, 1.0f);
}


///////////////////////////////////////////////////////////////////////////////////////////////
// eNjbN

technique MainTec < string MMDPass = "object"; > {
    pass DrawShadow {
        VertexShader = compile vs_2_0 HeightMap_VS();
        PixelShader  = compile ps_2_0 HeightMap_PS();
    }
}

technique MainTecSS < string MMDPass = "object_ss"; > {
    pass DrawShadow {
        VertexShader = compile vs_2_0 HeightMap_VS();
        PixelShader  = compile ps_2_0 HeightMap_PS();
    }
}

///////////////////////////////////////////////////////////////////////////////////////////////

// ȉ\
technique EdgeTec < string MMDPass = "edge"; > { }
technique ShadowTec < string MMDPass = "shadow"; > { }
technique ZplotTec < string MMDPass = "zplot"; > { }

